]> diplodocus.org Git - nmh/blob - test/scan/test-scan-multibyte
Fix error message when attempting to xmh_realloc() 0 bytes.
[nmh] / test / scan / test-scan-multibyte
1 #!/bin/sh
2 ############################################################
3 #
4 # Test scan to see if multibyte support (UTF-8 locale) works
5 #
6 # Other tests will get the normal ASCII case, so all we care
7 # about here is UTF-8 encoded headers (RFC 2047).
8 #
9 # Note that this file should be edited via a UTF-8 aware
10 # editor, since UTF-8 characters are in it.
11 #
12 ############################################################
13
14 set -e
15
16 if test -z "${MH_OBJ_DIR}"; then
17 srcdir=`dirname "$0"`/../..
18 MH_OBJ_DIR=`cd "$srcdir" && pwd`; export MH_OBJ_DIR
19 fi
20
21 . "$MH_OBJ_DIR/test/common.sh"
22
23 setup_test
24
25 if test "${MULTIBYTE_ENABLED}" -ne 1; then
26 test_skip "configure did not detect multibyte support"
27 fi
28
29 require_locale en_US.UTF-8 en_US.UTF8 en_US.utf-8 en_US.utf8
30
31 #
32 # Create a test message with RFC 2047 headers we can scan
33 #
34 # In this Subject header in this message is a "n" with a Combining Diaeresis
35 # (U+0308). There is different interpretation of this character with respect
36 # to wcwidth() (which is supposed to return the column width of a character).
37 # We use a test program to determine what the output width of U+0308 is
38 # and adjust our test output appropriately.
39 #
40 # True Spın̈al Tap fans will note that David st Hubbins was born in Squatney,
41 # London, England, and thus having his name language-tagged with "cy" is almost
42 # certainly incorrect. But in his own words: "Here lies David st Hubbins,
43 # and why not?".
44 #
45 # The second "* in the To line is just to exercise the parser a bit.
46 #
47
48 cat > "${MH_TEST_DIR}/Mail/inbox/11" <<EOF
49 From: David =?utf-8*cy?q?=EF=AC=86?= Hubbins <hubbins@example.com>
50 To: Sir Denis =?utf-8*?q?Eton=E2=80=93Hogg? <sirdenis@example.com>
51 Date: Friday, 2 Mar 1984 00:00:00
52 Subject: =?utf-8?q?Sp=C4=B1n=CC=88al_Tap_=E2=86=92_Tap_into_America!?=
53
54 Things are looking great!
55 EOF
56
57 width=`${MH_OBJ_DIR}/test/getcwidth "→n̈"`
58 if test $? -ne 0; then
59 echo "getcwidth failed to run"
60 exit 1
61 fi
62
63 expected="$MH_TEST_DIR/$$.expected"
64 actual="$MH_TEST_DIR/$$.actual"
65
66 if test "$width" -eq 3; then
67 cat > "$expected" <<EOF
68 11 03/02 David st Hubbins Spın̈al Tap → Tap into America!<<Things are looki
69 EOF
70 elif test "$width" -eq 2; then
71 cat > "$expected" <<EOF
72 11 03/02 David st Hubbins Spın̈al Tap → Tap into America!<<Things are lookin
73 EOF
74 else
75 echo "Unsupported width for UTF-8 test string: $width"
76 exit 1
77 fi
78
79 run_prog scan -width 80 +inbox 11 > $actual || exit 1
80 check "$expected" "$actual"
81
82 #
83 # Check decoding with an invalid multibyte sequence. We skip this test
84 # if we don't have iconv support, since it requires converting from one
85 # character set to another. Be sure we created the test file, though, because
86 # it's required for the test right after it.
87 #
88
89 cat >`mhpath new` <<EOF
90 From: Test12 <test12@example.com>
91 To: Some User <user@example.com>
92 Date: Mon, 31 Dec 2012 00:00:00
93 Message-Id: 12@test.nmh
94 Subject: =?UTF-8?B?MjAxMyBOZXcgWWVhcuKAmXMgRGVhbHMhIFN0YXJ0IHRoZSB5ZWFy?=
95 =?UTF-8?B?IHJpZ2h0IHdpdGggYmlnIHNhdmluZ3M=?=
96
97 This message has an encoded Subject with an invalid character for
98 single-byte character sets, but it (U+2019) is valid UTF-8.
99 EOF
100
101 if test "$ICONV_ENABLED" -eq 1; then
102 cat >"$expected" <<EOF
103 12 12/31 Test12 2013 New Year?s Deals! Start the year right
104 EOF
105
106 # Don't use run_prog here because it loses the environment setting.
107 LC_ALL=C scan -width 74 last >"$actual"
108 check "$expected" "$actual"
109 fi
110
111 #
112 # Find out the width of our Unicode apostrophe (U+2019). Some implementations
113 # say it has a width of 2, but that seems totally bizarre to me.
114 #
115
116 width=`${MH_OBJ_DIR}/test/getcwidth U+2019`
117 if test $? -ne 0; then
118 echo "getcwidth failed to run"
119 exit 1
120 fi
121
122 # check scan width with a valid multibyte sequence
123 if test "$width" -eq 1; then
124 cat >"$expected" <<EOF
125 12 12/31 Test12 2013 New Year’s Deals! Start the year right
126 EOF
127 elif test "$width" -eq 2; then
128 cat >"$expected" <<EOF
129 12 12/31 Test12 2013 New Year’s Deals! Start the year righ
130 EOF
131 else
132 echo "Unsupported width for U+2019: $width"
133 fi
134
135 run_prog scan -width 74 last >"$actual"
136 check "$expected" "$actual"
137
138
139 if test "$ICONV_ENABLED" -eq 1; then
140 cat >"$expected" <<EOF
141 13 01/13 sender@example.co <<The Subject: is an encoded single quote, 0x92.
142 EOF
143
144 cat >"${MH_TEST_DIR}/Mail/inbox/13" <<EOF
145 From: <sender@example.com>
146 Subject: =?iso-8859-1?B?kgo=?=
147 Date: Mon, 13 Jan 2014 14:18:33 -0600
148
149 The Subject: is an encoded single quote, 0x92. cpstripped() didn't
150 properly count it when decoding, which could be seen with:
151
152 scan -format '%(decode{subject})%{body}'
153
154 The scan listing was two characters too long.
155 EOF
156
157 run_prog scan -width 80 last >"$actual"
158 check "$expected" "$actual"
159 fi
160
161
162 exit $failed